/**
  ******************************************************************************
  * @file    main.c
  * @author  MCD Application Team
  * @version V0.0.3
  * @date    Feb 2010
  * @brief   This file contains main test loop for optimized I2C master
  ******************************************************************************
  *
* Function name : main
* Description 	: Main testing loop
* Input param 	: None
* Return 		    : None
* See also 		  : None
*******************************************************************************/
void main (void) 
{ 
	
	// - System CLK configuration 
	#ifdef FAST_I2C_MODE
  CLK->CKDIVR = 0x00;             // sys clock / 1
	#else
  CLK->CKDIVR = 0x01;             // sys clock / 2
	#endif
 
  // - GPIO initialisation for LED
  GPIOA->DDR |=  0xF0;            // GPIO init
  GPIOA->CR1 |=  0xF0;            // all LEDs push pull outputs
  GPIOA->ODR |=  0xF0;
  
  
	// initialize timer 4 mandatory for I2C timout measurement 
  TIM4_Init();                    
  
	// Initialize I2C for communication
	I2C_Init();                     
	
	// Enable all interrupt
  enableInterrupts();

  // main loop 
	while (!I2C_WriteRegister(0x51,SEV_BIT_ADDRESS,STOP,0x05, dummy_Tab));
	while(1) 
	{

		while (!I2C_WriteRegister(0x51,SEV_BIT_ADDRESS,NOSTOP,0x01, dummy_Tab));
		while (!I2C_ReadRegister(0x51,SEV_BIT_ADDRESS,NOSTOP,0x03, dummy));
		
		while (!I2C_WriteRegister(0x51,SEV_BIT_ADDRESS,NOSTOP,0x01, dummy_Tab));
		while (!I2C_ReadRegister(0x51,SEV_BIT_ADDRESS,NOSTOP,0x02, dummy));
		
		while (!I2C_WriteRegister(0x51,SEV_BIT_ADDRESS,NOSTOP,0x01, dummy_Tab));
		while (!I2C_ReadRegister(0x51,SEV_BIT_ADDRESS,NOSTOP,0x01, dummy));
	}
	
}





















