/**
  ******************************************************************************
  * file main.c
  * brief This file contains the main function for I2C interrupt mode example.
  * author STMicroelectronics - MCD Application Team
  * version V1.0.0
  * date 01/03/2010
  ******************************************************************************
  *
  */

// Includes ------------------------------------------------------------------
#include "stm8s.h"
#include "I2c_slave_interrupt.h"
// Private typedef -----------------------------------------------------------
// Private define ------------------------------------------------------------
// Private macro -------------------------------------------------------------
// Private variables --------------------------------------------------------- 
// Private function prototypes -----------------------------------------------
// Private functions ---------------------------------------------------------
// Public functions ----------------------------------------------------------

 /*
  * Example firmware main entry point.
  * Parameters: None
  * Retval . None
  */
	
void main(void)
{
	
	CLK->CKDIVR = 0;                // sys clock /1

	// Init GPIO for I2C use 
	GPIOE->CR1 |= 0x06;
	GPIOE->DDR &= ~0x06;
	GPIOE->CR2 &= ~0x06;

	// Initialise I2C for communication 
	Init_I2C();
	
	// Enable general interrupts 
	enableInterrupts();
	
	// Main Loop 
  while(1);
}

